.TH "CM_MEMB_DATA" "3" "May 2003" "" "Red Hat Cluster Manager API Library"
.SH NAME
memb_local_id, memb_count, memb_online, memb_low_id, memb_high_id,
memb_mask_gained, memb_mask_lost, memb_mask_str \-
Cluster Membership Data Operations
.SH SYNOPSIS
.nf
.B #include <clumanager/cm_api.h>
.B #include <stdint.h>
.sp
.BI "int memb_local_id(void);"
.sp
.BI "int memb_count(memb_mask_t mask);"
.BI "int memb_online(memb_mask_t mask, uint32_t member_id);"
.sp
.BI "int memb_low_id(memb_mask_t mask);"
.BI "int memb_high_id(memb_mask_t mask);"
.sp
.BI "void memb_mark_up(memb_mask_t mask, uint32_t member_id);"
.BI "void memb_mark_down(memb_mask_t mask, uint32_t member_id);"
.sp
.BI "int memb_mask_gained(memb_mask_t dest, memb_mask_t old_view, memb_mask_t new_view);"
.BI "int memb_mask_lost(memb_mask_t dest, memb_mask_t old_view, memb_mask_t new_view);"
.sp
.BI "char *memb_mask_str(memb_mask_t mask);"
.fi
.SH DESCRIPTION
These functions manipulate and extract information from a cluster membership
bitmask. The \fBmemb_local_id()\fP function determines the member number of
the cluster member on which the function was called.
.LP
The \fBmemb_count()\fP function determines the number of members online in
a given membership \fBmask\fP.
.LP
The \fBmemb_online()\fP function determines whether or not a member (specified
by \fBmember_id\fP) has its bit set within a given membership mask.
.LP
The \fBmemb_low_id()\fP function determines the lowest member number
online in a given membership \fBmask\fP.
.LP
The \fBmemb_high_id()\fP function determines the highest member number
online in a given membership \fBmask\fP.
.B mask.
.LP
The \fBmemb_mark_up()\fP function sets the bit corresponding to
\fBmember\fP in the given membership mask.
.LP
The \fBmemb_mark_down()\fP function clears the bit corresponding to
\fBmember\fP in the given membership mask.
.LP
The \fBmemb_mask_gained()\fP function creates a bitmask showing which members
were gained (had their bits turned on) between \fBold_view\fP and
\fBnew_view\fP by setting the corresponding bits \fBdest\fP.
.LP
The \fBmemb_mask_lost()\fP function creates a bitmask showing which members
were lost (had their bits turned off) between \fBold_view\fP and
\fBnew_view\fP by setting the corresponding bits \fBdest\fP.
.LP
The \fBmemb_mask_str()\fP function generates a human-readable string of the
bitmask represented by \fBmask\fP and returns said string.  The string is
a static buffer, and should not be freed by the caller.

.SH "RETURN VALUE"
.B memb_local_id()
returns the ID of the cluster member on which it was called, or -1 if it was
not determinable.
.LP
.B memb_count()
returns the count of the number of member bits set within a given membership
mask.
.LP
.B memb_online()
returns 0 if the given member number is not set, or 1 if it is set.
.LP
.B memb_low_id()
returns the ID of the lowest-numbered cluster member whose bit is set within
a given membership mask.
.LP
.B memb_high_id()
returns the ID of the highest-numbered cluster member whose bit is set
within a given membership mask.
.LP
The 
.B memb_mask_gained()
and
.B memb_mask_lost()
functions return 0.
.LP
The
.B memb_mask_str()
function returns a pointer to a static string, or NULL if said string could
not be constructed.

.SH "NOTES"
These functions may be implemented as macros.
.SH "SEE ALSO"
cm_event_data(3)
